import { _decorator, Component, director, easing, Node, Touch, Tween, tween, Vec2 } from 'cc';
const { ccclass, property } = _decorator;

const tempV2_0 = new Vec2();

@ccclass('fogCtrl')
export class fogCtrl extends Component {

    onEnable() {
        this.node.on(Node.EventType.TOUCH_END,this._onClickCanvas,this);
    }
    onDisable(){
        this.node.off(Node.EventType.TOUCH_END,this._onClickCanvas,this);
        const fog = director.getScene().globals.fog;
        Tween.stopAllByTarget(fog);
    }

    /* tween the fog once the canvas layer is touched */
    _onClickCanvas(event:Touch){
        event.getUILocation(tempV2_0);
        const fog = director.getScene().globals.fog;
        fog.fogStart = tempV2_0.x;
        fog.fogEnd = tempV2_0.y;
        fog.fogRange = 0;
        tween(fog).to(2,{fogRange:2000},{easing:easing.sineIn}).start()
    }

}

