import { _decorator, Component, Slider, Sprite } from 'cc';
const { ccclass, property } = _decorator;

@ccclass('uniformCtrl')
export class uniformCtrl extends Component {
    @property(Sprite) sp: Sprite
    start() {
        this.initUniforms();
    }

    /* bind uniforms with sliders */
    initUniforms() {
        /* use Material for single instance, sharedMaterial for shared instance */
        const mat = this.sp.sharedMaterial;
        const pass = mat.passes[0];
        for (var i = 1; i <= 4; i++) {
            const handle = pass.getHandle("mix" + i);
            const slider = this.node.getChildByName("Slider" + i).getComponent(Slider);
            slider.progress = pass.getUniform(handle, null);
            slider.node.on("slide", ((s: Slider) => {
                pass.setUniform(handle, s.progress);
            }), this);
        }
    }
}

